//+--------------------------------------------------------------------------------------+
//|    28 Aug 2013                                                                                  |
//+--------------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Aqua//Lime
#property indicator_color2 Orange
#property indicator_color3 Lime
#property indicator_color4 Red//DarkOrange
#property indicator_color5 Red//DarkOrange
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_level1 0.0

#import "libSSA.dll"
   void fastSingular(double& sourceArray[],int arraySize, int lag, int numberOfComputationLoops, double& destinationArray[]);
#import

//
//
//
//
//

extern string TimeFrame                    = "Current time frame";
extern int    SSAPrice                     = PRICE_CLOSE;
extern int    SSALag                       = 15;//25
extern int    SSANumberOfComputations      = 2;
extern int    SSAPeriodNormalization       = 25;
extern int    SSANumberOfBars              = 300;
extern int    FirstBar                     = 400; 
extern double HighLowStep                  = 0.005;

extern bool   alertsOn                     = true;
extern bool   alertsOnSlope                = true;
extern bool   alertsOnCorridorCross        = true;
extern bool   alertsOnCurrent              = true;
extern bool   alertsMessage                = true;
extern bool   alertsSound                  = true;//**********NB!
extern bool   alertsNotify                 = false;
extern bool   alertsEmail                  = false;

extern bool   arrowsVisible                = true;
extern string arrowsIdentifier             = "corridor SSA arrows1";
extern double arrowsUpperGap               = 1.0;
extern double arrowsLowerGap               = 0.0;

extern bool   arrowsOnSlope                = true;
extern color  arrowsOnSlopeUpColor         = Aqua;//*********
extern color  arrowsOnSlopeDnColor         = Red;
extern int    arrowsOnSlopeUpCode          = 233;
extern int    arrowsOnSlopeDnCode          = 234;
extern int    arrowsOnSlopeSize            = 2;

extern bool   arrowsOnCorridorCross        = true;//******
extern color  arrowsOnCorridorCrossUpColor = Yellow;//DeepSkyBlue;
extern color  arrowsOnCorridorCrossDnColor = Yellow;//PalevioletRed;
extern int    arrowsOnCorridorCrossUpCode  = 165;
extern int    arrowsOnCorridorCrossDnCode  = 165;
extern int    arrowsOnCorridorCrossSize    = 1;
//
//
//
//
//

double in[];
double inda[];
double indb[];
double no[];
double ssaIn[];
double ssaOut[];
double max[];
double min[];
double slope[];
double trend[];

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,max);
      SetIndexBuffer(1,min);
      SetIndexBuffer(2,in);
      SetIndexBuffer(3,inda);
      SetIndexBuffer(4,indb);
      SetIndexBuffer(5,no);
      SetIndexBuffer(6,slope);
      SetIndexBuffer(7,trend);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" Corridor SSA normalized end-pointed");
   return(0);
}

//
//
//
//
//

int deinit()
{  
   if (!calculateValue && arrowsVisible) deleteArrows();  
   
return(0); 
}

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { in[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
      
   if (calculateValue || timeFrame==Period())
   {
      if (slope[limit]==-1) CleanPoint(limit,inda,indb);
      for(int i=limit; i>=0; i--)
      {
         double ma    = iMA(NULL,0,SSAPeriodNormalization,0,MODE_SMA,SSAPrice,i);
         double dev   = 3.0*iStdDev(NULL,0,SSAPeriodNormalization,0,MODE_SMA,SSAPrice,i);
         double price = iMA(NULL,0,1,0,MODE_SMA,SSAPrice,i);
               if (dev == 0) dev = 0.000001;
                no[i] = (price-ma)/dev;
                in[i] = 0;
                min[i] = 0;
                max[i] = 0;
            
            //
            //
            //
            //
            //
            
            if (i<=FirstBar)
            {
               int ssaBars = MathMin(Bars-i,SSANumberOfBars);
               if (ssaBars<SSALag) continue;
               if (ArraySize(ssaIn) != ssaBars)
               {
                  ArrayResize(ssaIn ,ssaBars);
                  ArrayResize(ssaOut,ssaBars);
               }
               ArrayCopy(ssaIn,no,0,i,ssaBars);
 
               fastSingular(ssaIn,ssaBars,SSALag,SSANumberOfComputations,ssaOut);
               inda[i] = EMPTY_VALUE;
               indb[i] = EMPTY_VALUE;
               in[i]   = ssaOut[0];
               max[i]  = MathMax(in[i],max[i+1]-HighLowStep);
               min[i]  = MathMin(in[i],min[i+1]+HighLowStep);
               slope[i] = slope[i+1];
               trend[i] = trend[i+1];
                  if (in[i]>in[i+1])  slope[i] =  1;
                  if (in[i]<in[i+1])  slope[i] = -1;
                  if (in[i]<=min[i])  trend[i] =  1;
                  if (in[i]>=max[i])  trend[i] = -1;
         	      if (slope[i] == -1) PlotPoint(i,inda,indb,in);
                  manageArrow(i);
            }                   
      }                  
      SetIndexDrawBegin(0,Bars-FirstBar);
      SetIndexDrawBegin(1,Bars-FirstBar);
      SetIndexDrawBegin(2,Bars-FirstBar);
      SetIndexDrawBegin(3,Bars-FirstBar);
      SetIndexDrawBegin(4,Bars-FirstBar);
      manageAlerts();
      return(0); 
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (slope[limit]==-1) CleanPoint(limit,inda,indb);
   for(i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         max[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSAPrice,SSALag,SSANumberOfComputations,SSAPeriodNormalization,SSANumberOfBars,FirstBar,HighLowStep,0,y);
         min[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSAPrice,SSALag,SSANumberOfComputations,SSAPeriodNormalization,SSANumberOfBars,FirstBar,HighLowStep,1,y);
         in[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSAPrice,SSALag,SSANumberOfComputations,SSAPeriodNormalization,SSANumberOfBars,FirstBar,HighLowStep,2,y);
         slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSAPrice,SSALag,SSANumberOfComputations,SSAPeriodNormalization,SSANumberOfBars,FirstBar,HighLowStep,6,y);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSAPrice,SSALag,SSANumberOfComputations,SSAPeriodNormalization,SSANumberOfBars,FirstBar,HighLowStep,7,y);
         inda[i]  = EMPTY_VALUE;
         indb[i]  = EMPTY_VALUE;
      	      if (slope[i] == -1) PlotPoint(i,inda,indb,in);
               manageArrow(i);
   }
   SetIndexDrawBegin(0,Bars-FirstBar*timeFrame/Period());
   SetIndexDrawBegin(1,Bars-FirstBar*timeFrame/Period());
   SetIndexDrawBegin(2,Bars-FirstBar*timeFrame/Period());
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
      ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
      string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
      if (arrowsOnSlope && slope[i] != slope[i+1])
      {
         if (slope[i] == 1) drawArrow("1",0.5,i,arrowsOnSlopeUpColor,arrowsOnSlopeUpCode,arrowsOnSlopeSize,false);
         if (slope[i] ==-1) drawArrow("1",0.5,i,arrowsOnSlopeDnColor,arrowsOnSlopeDnCode,arrowsOnSlopeSize, true);
      } 
      if (arrowsOnCorridorCross && trend[i] != trend[i+1])
      {
         if (trend[i] == 1) drawArrow("2",1,i,arrowsOnCorridorCrossUpColor,arrowsOnCorridorCrossUpCode,arrowsOnCorridorCrossSize,false);
         if (trend[i] ==-1) drawArrow("2",1,i,arrowsOnCorridorCrossDnColor,arrowsOnCorridorCrossDnCode,arrowsOnCorridorCrossSize, true);
      }
                                   
   }         
}       

//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,int theWidth,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar," Corridor SSA sloping up");
            if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar," Corridor SSA sloping down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnCorridorCross && trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert(time2,mess2,whichBar," Corridor SSA crossed lower corridor");
            if (trend[whichBar] == -1) doAlert(time2,mess2,whichBar," Corridor SSA crossed upper corridor");
         }              
     }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol(),TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Corridor SSA "),message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Corridor SSA " +" "+message));
             if (alertsSound)   PlaySound("alert2.wav");
      }
}